# Machine Learning

Discover the specifics of each method associated with building powerful machine learning models from scratch, making predictions and solving problems easily

## Simple Linear Regression

This function models the relationship between two continuous variables. The objective is to predict the value of an output variable based on the value of an input variable.

{% content-ref url="/pages/DbapNUJWsFnFhByXiC1G" %}
[Simple Linear Regression (ML\_R\_1)](/autogon-engine-studio/machine-learning/simple-linear-regression-ml_r_1.md)
{% endcontent-ref %}

## Multiple Linear Regression

This function models the relationship between more independent variables. The objective is to predict the value of an output variable based on the value of input variables.

{% content-ref url="/pages/Og4jxQ2bZ2JW8bey7qE1" %}
[Multiple Linear Regression (ML\_R\_2)](/autogon-engine-studio/machine-learning/multiple-linear-regression-ml_r_2.md)
{% endcontent-ref %}

## Polynomial Linear Regression

This function uses the relationship between variables to find the best non-linear fit through the data points.

{% content-ref url="/pages/rvmKAClKdCk0LFpGRpBg" %}
[Polynomial Linear Regression (ML\_R\_3)](/autogon-engine-studio/machine-learning/polynomial-linear-regression-ml_r_3.md)
{% endcontent-ref %}

## Support Vector Regression

This function can be used for solving both linear and non-linear problems.

{% content-ref url="/pages/YAdV0wmljZ9h3N4HBBxU" %}
[Support Vector Regression (ML\_R\_4)](/autogon-engine-studio/machine-learning/support-vector-regression-ml_r_4.md)
{% endcontent-ref %}

## Decision Tree Regression

This function splits the data into smaller subsets while at the same time an associated decision rule is used to predict the target variable, built in the form of a tree structure.

{% content-ref url="/pages/uYNB55eqtrazQuvy34ry" %}
[Decision Tree Regression (ML\_R\_5)](/autogon-engine-studio/machine-learning/decision-tree-regression-ml_r_5.md)
{% endcontent-ref %}

## Random Forest Regression

This function builds multiple decision trees and combines their outputs to make a final prediction.

{% content-ref url="/pages/A7qwmMWp7V0j5kfdq32t" %}
[Random Forest Regression (ML\_R\_6)](/autogon-engine-studio/machine-learning/random-forest-regression-ml_r_6.md)
{% endcontent-ref %}

## Logistic Regression

This function performs analysis on a dataset and returns the predicted binary outcome based on the input independent variables.

{% content-ref url="/pages/YGBhkmI9mkZvbaDh2ccl" %}
[Logistic Regression (ML\_CN\_1)](/autogon-engine-studio/machine-learning/logistic-regression-ml_cn_1.md)
{% endcontent-ref %}

## K-Nearest Neighbours

This function finds the K number of training examples closest (nearest neighbors) to the input data and then classifying the input data based on the majority class of its nearest neighbors.

{% content-ref url="/pages/zzgVbR9CAPOzXHWqpiXd" %}
[K-Nearest Neighbors - KNN (ML\_CN\_2)](/autogon-engine-studio/machine-learning/k-nearest-neighbors-knn-ml_cn_2.md)
{% endcontent-ref %}

## Support Vector Machine

This function finds the K number of training examples closest (nearest neighbors) to the input data and then classifying the input data based on the majority class of its nearest neighbors.

{% content-ref url="/pages/joog1HdIq45cGAvNnOPU" %}
[Support Vector Machine (ML\_CN\_3)](/autogon-engine-studio/machine-learning/support-vector-machine-ml_cn_3.md)
{% endcontent-ref %}

## Kernel SVM

This function finds the K number of training examples closest (nearest neighbors) to the input data and then classifying the input data based on the majority class of its nearest neighbors.

{% content-ref url="/pages/RMCpV9Q5cNj8rAmJYQmu" %}
[Kernel SVM (ML\_CN\_4)](/autogon-engine-studio/machine-learning/kernel-svm-ml_cn_4.md)
{% endcontent-ref %}

## Naive Bayes

This function finds the K number of training examples closest (nearest neighbors) to the input data and then classifying the input data based on the majority class of its nearest neighbors.

{% content-ref url="/pages/OMFXhT52Rbx5tZVfyAKS" %}
[Naive Bayes (ML\_CN\_5)](/autogon-engine-studio/machine-learning/naive-bayes-ml_cn_5.md)
{% endcontent-ref %}

## Decision Tree Classification

This function finds the K number of training examples closest (nearest neighbors) to the input data and then classifying the input data based on the majority class of its nearest neighbors.

{% content-ref url="/pages/W301YLHozh2fZYrJn6Vb" %}
[Decision Tree Classification (ML\_CN\_6)](/autogon-engine-studio/machine-learning/decision-tree-classification-ml_cn_6.md)
{% endcontent-ref %}

## Random Forest Classification

This function finds the K number of training examples closest (nearest neighbors) to the input data and then classifying the input data based on the majority class of its nearest neighbors.

{% content-ref url="/pages/sTwb1plRIVVOdi1JGUIG" %}
[Random Forest Classification (ML\_CN\_7)](/autogon-engine-studio/machine-learning/random-forest-classification-ml_cn_7.md)
{% endcontent-ref %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.autogon.ai/autogon-engine-studio/machine-learning.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
